//+------------------------------------------------------------------+ 
//| CALCOLO LOTTI CON FIXED FRACTIONAL METHOD                        |                                           | 
//+------------------------------------------------------------------+ 

extern double FixedLots      = 0.00; // lasciare 0 per usare il Fixed Fractional Method
extern double Risk           = 0.01; // rischio % sul capitale

double Stop_Size_Long, Stop_Size_Short;
double Spread;
double pipValue;
double Stop_Long, Stop_Short;
double Lots_Long, Lots_Short;
 
 

// 1. Calcolo Lotti per posizioni Long

double LotSize_Long() 
{
      if(FixedLots > 0.00)
        {
        return (FixedLots); 
        }
      else
        {
        Stop_Size_Long = (Ask-Stop_Long)/Point;
        Spread         = Ask - Bid ;
      
        pipValue  = MarketInfo(Symbol(), MODE_TICKVALUE);   
        Lots_Long = ( (AccountFreeMargin() * Risk) / ((Stop_Size_Long+Spread)*pipValue) ) ;
        double lotStep  = MarketInfo(Symbol(), MODE_LOTSTEP);
        int digits = 0;
        if(lotStep <= 0.01) // cio se stiamo usando microlotti
           digits = 2;
        else if(lotStep <= 0.1) // cio se stiamo usando minilotti
           digits = 1;
        Lots_Long = NormalizeDouble(Lots_Long, digits); // normalizza i lotti con 2 decimali se sono microlotti
        // oppure con 1 decimale se sono minilotti
  
        double minLots = MarketInfo(Symbol(), MODE_MINLOT); // lotto minimo da tradare
        if(Lots_Long < minLots)
        Lots_Long = minLots; // arrotonda comunque al lotto minimo da tradare 
        return(Lots_Long);
        }
}
 
 
// 2. Calcolo Lotti per posizioni Short

double LotSize_Short() 
{
    
      if(FixedLots > 0.00)
        {
        return (FixedLots); 
        }
      else
        {
        Stop_Size_Short = (Stop_Short-Bid)/Point;
        Spread          = Ask - Bid ;
      
        pipValue  = MarketInfo(Symbol(), MODE_TICKVALUE);   
        Lots_Short = ( (AccountFreeMargin() * Risk) / ((Stop_Size_Short+Spread)*pipValue) ) ;
        double lotStep  = MarketInfo(Symbol(), MODE_LOTSTEP);
        int digits = 0;
        if(lotStep <= 0.01) // cio se stiamo usando microlotti
           digits = 2;
        else if(lotStep <= 0.1) // cio se stiamo usando minilotti
           digits = 1;
        Lots_Short = NormalizeDouble(Lots_Short, digits); // normalizza i lotti con 2 decimali se sono microlotti
        // oppure con 1 decimale se sono minilotti
  
        double minLots = MarketInfo(Symbol(), MODE_MINLOT); // lotto minimo da tradare
        if(Lots_Short < minLots)
        Lots_Short = minLots; // arrotonda comunque al lotto minimo da tradare 
        return(Lots_Short);
        }
}


